Index: /branches/2522_RefactorPluginInfrastructure/HeuristicLab.Algorithms.DataAnalysis/3.4/HeuristicLab.Algorithms.DataAnalysis-3.4.csproj
===================================================================
--- /branches/2522_RefactorPluginInfrastructure/HeuristicLab.Algorithms.DataAnalysis/3.4/HeuristicLab.Algorithms.DataAnalysis-3.4.csproj	(revision 16142)
+++ /branches/2522_RefactorPluginInfrastructure/HeuristicLab.Algorithms.DataAnalysis/3.4/HeuristicLab.Algorithms.DataAnalysis-3.4.csproj	(revision 16143)
@@ -1,491 +1,59 @@
 ﻿<?xml version="1.0" encoding="utf-8"?>
-<Project DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003" ToolsVersion="4.0">
+<Project Sdk="Microsoft.NET.Sdk">
   <PropertyGroup>
-    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
-    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
-    <SchemaVersion>2.0</SchemaVersion>
-    <ProjectGuid>{2E782078-FA81-4B70-B56F-74CE38DAC6C8}</ProjectGuid>
-    <OutputType>Library</OutputType>
-    <AppDesignerFolder>Properties</AppDesignerFolder>
-    <RootNamespace>HeuristicLab.Algorithms.DataAnalysis</RootNamespace>
-    <AssemblyName>HeuristicLab.Algorithms.DataAnalysis-3.4</AssemblyName>
+    <TargetFramework>netstandard2.0</TargetFramework>
+    <Copyright>(c) 2002-2018 HEAL</Copyright>
+    <Product>HeuristicLab</Product>
     <SignAssembly>true</SignAssembly>
     <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
-    <FileUpgradeFlags>
-    </FileUpgradeFlags>
-    <OldToolsVersion>3.5</OldToolsVersion>
-    <UpgradeBackupLocation>
-    </UpgradeBackupLocation>
-    <StartupObject>
-    </StartupObject>
-    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
-    <TargetFrameworkProfile>
-    </TargetFrameworkProfile>
-    <PublishUrl>publish\</PublishUrl>
-    <Install>true</Install>
-    <InstallFrom>Disk</InstallFrom>
-    <UpdateEnabled>false</UpdateEnabled>
-    <UpdateMode>Foreground</UpdateMode>
-    <UpdateInterval>7</UpdateInterval>
-    <UpdateIntervalUnits>Days</UpdateIntervalUnits>
-    <UpdatePeriodically>false</UpdatePeriodically>
-    <UpdateRequired>false</UpdateRequired>
-    <MapFileExtensions>true</MapFileExtensions>
-    <ApplicationRevision>0</ApplicationRevision>
-    <ApplicationVersion>1.0.0.%2a</ApplicationVersion>
-    <IsWebBootstrapper>false</IsWebBootstrapper>
-    <UseApplicationTrust>false</UseApplicationTrust>
-    <BootstrapperEnabled>true</BootstrapperEnabled>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
-    <DebugSymbols>true</DebugSymbols>
-    <DebugType>full</DebugType>
-    <Optimize>false</Optimize>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
-    <DefineConstants>DEBUG;TRACE</DefineConstants>
-    <ErrorReport>prompt</ErrorReport>
-    <WarningLevel>4</WarningLevel>
-    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
-    <Prefer32Bit>false</Prefer32Bit>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
-    <DebugType>pdbonly</DebugType>
-    <Optimize>true</Optimize>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
-    <DefineConstants>TRACE</DefineConstants>
-    <ErrorReport>prompt</ErrorReport>
-    <WarningLevel>4</WarningLevel>
-    <DocumentationFile>
-    </DocumentationFile>
-    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
-    <Prefer32Bit>false</Prefer32Bit>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
-    <DebugSymbols>true</DebugSymbols>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
-    <DefineConstants>DEBUG;TRACE</DefineConstants>
-    <DebugType>full</DebugType>
-    <PlatformTarget>x86</PlatformTarget>
-    <ErrorReport>prompt</ErrorReport>
-    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
-    <Prefer32Bit>false</Prefer32Bit>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
-    <DefineConstants>TRACE</DefineConstants>
-    <DocumentationFile>
-    </DocumentationFile>
-    <Optimize>true</Optimize>
-    <DebugType>pdbonly</DebugType>
-    <PlatformTarget>x86</PlatformTarget>
-    <ErrorReport>prompt</ErrorReport>
-    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
-    <Prefer32Bit>false</Prefer32Bit>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
-    <DebugSymbols>true</DebugSymbols>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
-    <DefineConstants>DEBUG;TRACE</DefineConstants>
-    <DebugType>full</DebugType>
-    <PlatformTarget>x64</PlatformTarget>
-    <ErrorReport>prompt</ErrorReport>
-    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
-    <Prefer32Bit>false</Prefer32Bit>
-  </PropertyGroup>
-  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
-    <DefineConstants>TRACE</DefineConstants>
-    <DocumentationFile>
-    </DocumentationFile>
-    <Optimize>true</Optimize>
-    <DebugType>pdbonly</DebugType>
-    <PlatformTarget>x64</PlatformTarget>
-    <ErrorReport>prompt</ErrorReport>
-    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
-    <Prefer32Bit>false</Prefer32Bit>
+    <AssemblyVersion>3.4.0.0</AssemblyVersion>
+    <AssemblyFileVersion>3.4.11.0</AssemblyFileVersion>
+    <RootNamespace>HeuristicLab.Algorithms.DataAnalysis</RootNamespace>
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="ALGLIB-3.7.0, Version=3.7.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+    <PackageReference Include="Microsoft.Windows.Compatibility" Version="2.0.1" />
+    <PackageReference Include="System.Drawing.Common" Version="4.5.0" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Algorithms.GradientDescent\3.3\HeuristicLab.Algorithms.GradientDescent-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm\3.3\HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.3\HeuristicLab.Common.Resources-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.RealVectorEncoding\3.3\HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding\3.4\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic.Classification\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.Classification-3.4.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic.Regression\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Problems.Instances\3.3\HeuristicLab.Problems.Instances-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Random\3.3\HeuristicLab.Random-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Selection\3.3\HeuristicLab.Selection-3.3.csproj" />
+  </ItemGroup>
+  <ItemGroup>
+    <Reference Include="ALGLIB-3.7.0, Version=3.7.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
       <HintPath>..\..\bin\ALGLIB-3.7.0.dll</HintPath>
       <Private>False</Private>
     </Reference>
-    <Reference Include="LibSVM-3.12, Version=3.12.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+    <Reference Include="LibSVM-3.12, Version=3.12.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
       <HintPath>..\..\bin\LibSVM-3.12.dll</HintPath>
       <Private>False</Private>
     </Reference>
-    <Reference Include="System" />
-    <Reference Include="System.Core">
-      <RequiredTargetFramework>3.5</RequiredTargetFramework>
-    </Reference>
-    <Reference Include="System.Drawing" />
   </ItemGroup>
-  <ItemGroup>
-    <Compile Include="BaselineClassifiers\OneFactorClassificationModel.cs" />
-    <Compile Include="BaselineClassifiers\OneFactorClassificationSolution.cs" />
-    <Compile Include="BaselineClassifiers\OneR.cs" />
-    <Compile Include="BaselineClassifiers\OneRClassificationModel.cs" />
-    <Compile Include="BaselineClassifiers\OneRClassificationSolution.cs" />
-    <Compile Include="BaselineClassifiers\ZeroR.cs" />
-    <Compile Include="CrossValidation.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="DoubleArrayExtensions.cs" />
-    <Compile Include="FixedDataAnalysisAlgorithm.cs" />
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceSpectralMixture.cs" />
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovariancePiecewisePolynomial.cs" />
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceNeuralNetwork.cs" />
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovariancePolynomial.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessBase.cs" />
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceConst.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceLinear.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceLinearArd.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceMask.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceMaternIso.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceNoise.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovariancePeriodic.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceProduct.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceRationalQuadraticArd.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceRationalQuadraticIso.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceScale.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceSquaredExponentialArd.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceSquaredExponentialIso.cs" />
-    <Compile Include="GaussianProcess\CovarianceFunctions\CovarianceSum.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\GaussianProcessClassificationSolutionCreator.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessClassificationModelCreator.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessClassification.cs" />
-    <Compile Include="GaussianProcess\MeanFunctions\MeanModel.cs" />
-    <Compile Include="GaussianProcess\MeanFunctions\MeanConst.cs" />
-    <Compile Include="GaussianProcess\MeanFunctions\MeanLinear.cs" />
-    <Compile Include="GaussianProcess\MeanFunctions\MeanProduct.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\MeanFunctions\MeanSum.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\MeanFunctions\MeanZero.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessHyperparameterInitializer.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessRegressionSolutionCreator.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessRegressionModelCreator.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessModelCreator.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="GaussianProcess\GaussianProcessCovarianceOptimizationProblem.cs" />
-    <Compile Include="GaussianProcess\Util.cs" />
-    <Compile Include="GaussianProcess\IMeanFunction.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessModel.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessRegression.cs" />
-    <Compile Include="GaussianProcess\GaussianProcessRegressionSolution.cs" />
-    <Compile Include="GaussianProcess\ICovarianceFunction.cs" />
-    <Compile Include="GBM\GradientBoostingRegressionAlgorithm.cs" />
-    <Compile Include="GradientBoostedTrees\IGradientBoostedTreesModel.cs" />
-    <Compile Include="GradientBoostedTrees\GradientBoostedTreesModelSurrogate.cs" />
-    <Compile Include="GradientBoostedTrees\GradientBoostedTreesAlgorithm.cs" />
-    <Compile Include="GradientBoostedTrees\GradientBoostedTreesAlgorithmStatic.cs" />
-    <Compile Include="GradientBoostedTrees\GradientBoostedTreesModel.cs" />
-    <Compile Include="GradientBoostedTrees\LossFunctions\AbsoluteErrorLoss.cs" />
-    <Compile Include="GradientBoostedTrees\LossFunctions\QuantileRegressionLoss.cs" />
-    <Compile Include="GradientBoostedTrees\LossFunctions\ILossFunction.cs" />
-    <Compile Include="GradientBoostedTrees\LossFunctions\LogisticRegressionLoss.cs" />
-    <Compile Include="GradientBoostedTrees\LossFunctions\RelativeErrorLoss.cs" />
-    <Compile Include="GradientBoostedTrees\LossFunctions\SquaredErrorLoss.cs" />
-    <Compile Include="GradientBoostedTrees\GradientBoostedTreesSolution.cs" />
-    <Compile Include="GradientBoostedTrees\RegressionTreeBuilder.cs" />
-    <Compile Include="GradientBoostedTrees\RegressionTreeModel.cs" />
-    <Compile Include="Interfaces\IGaussianProcessClassificationModelCreator.cs" />
-    <Compile Include="Interfaces\IGaussianProcessRegressionModelCreator.cs" />
-    <Compile Include="Interfaces\IGaussianProcessModelCreator.cs" />
-    <Compile Include="Interfaces\IGaussianProcessModel.cs" />
-    <Compile Include="Interfaces\IGaussianProcessSolution.cs" />
-    <Compile Include="Interfaces\INcaClassificationSolution.cs" />
-    <Compile Include="Interfaces\INcaModel.cs" />
-    <Compile Include="Interfaces\INearestNeighbourClassificationSolution.cs" />
-    <Compile Include="Interfaces\INearestNeighbourRegressionSolution.cs" />
-    <Compile Include="Interfaces\INearestNeighbourModel.cs" />
-    <Compile Include="Interfaces\INeuralNetworkEnsembleClassificationSolution.cs" />
-    <Compile Include="Interfaces\INeuralNetworkEnsembleRegressionSolution.cs" />
-    <Compile Include="Interfaces\INeuralNetworkEnsembleModel.cs" />
-    <Compile Include="Interfaces\INeuralNetworkClassificationSolution.cs" />
-    <Compile Include="Interfaces\INeuralNetworkRegressionSolution.cs" />
-    <Compile Include="Interfaces\INeuralNetworkModel.cs" />
-    <Compile Include="Interfaces\IRandomForestClassificationSolution.cs" />
-    <Compile Include="Interfaces\IRandomForestModel.cs" />
-    <Compile Include="Interfaces\IRandomForestRegressionSolution.cs" />
-    <Compile Include="Interfaces\ISupportVectorMachineModel.cs" />
-    <Compile Include="Interfaces\ISupportVectorMachineSolution.cs" />
-    <Compile Include="Interfaces\IDataAnalysisAlgorithm.cs" />
-    <Compile Include="KernelRidgeRegression\KernelFunctions\CicularKernel.cs" />
-    <Compile Include="KernelRidgeRegression\KernelFunctions\GaussianKernel.cs" />
-    <Compile Include="KernelRidgeRegression\KernelFunctions\IKernel.cs" />
-    <Compile Include="KernelRidgeRegression\KernelFunctions\InverseMultiquadraticKernel.cs" />
-    <Compile Include="KernelRidgeRegression\KernelFunctions\KernelBase.cs" />
-    <Compile Include="KernelRidgeRegression\KernelFunctions\MultiquadraticKernel.cs" />
-    <Compile Include="KernelRidgeRegression\KernelFunctions\PolysplineKernel.cs" />
-    <Compile Include="KernelRidgeRegression\KernelFunctions\ThinPlatePolysplineKernel.cs" />
-    <Compile Include="KernelRidgeRegression\KernelRidgeRegression.cs" />
-    <Compile Include="KernelRidgeRegression\KernelRidgeRegressionModel.cs" />
-    <Compile Include="kMeans\KMeansClustering.cs" />
-    <Compile Include="kMeans\KMeansClusteringModel.cs" />
-    <Compile Include="kMeans\KMeansClusteringSolution.cs" />
-    <Compile Include="kMeans\KMeansClusteringUtil.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Linear\LinearDiscriminantAnalysis.cs" />
-    <Compile Include="Linear\LinearRegression.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Linear\MultinomialLogitClassification.cs" />
-    <Compile Include="Linear\MultinomialLogitClassificationSolution.cs" />
-    <Compile Include="Linear\MultinomialLogitModel.cs" />
-    <Compile Include="Linear\Scaling.cs" />
-    <Compile Include="Nca\Initialization\INcaInitializer.cs" />
-    <Compile Include="Nca\Initialization\LdaInitializer.cs" />
-    <Compile Include="Nca\Initialization\NcaInitializer.cs" />
-    <Compile Include="Nca\Initialization\PcaInitializer.cs" />
-    <Compile Include="Nca\Initialization\RandomInitializer.cs" />
-    <Compile Include="Nca\Matrix.cs" />
-    <Compile Include="Nca\ModelCreation\INcaModelCreator.cs" />
-    <Compile Include="Nca\ModelCreation\NcaModelCreator.cs" />
-    <Compile Include="Nca\NcaAlgorithm.cs" />
-    <Compile Include="Nca\NcaClassificationSolution.cs" />
-    <Compile Include="Nca\NcaGradientCalculator.cs" />
-    <Compile Include="Nca\NcaModel.cs" />
-    <Compile Include="Nca\SolutionCreation\INcaSolutionCreator.cs" />
-    <Compile Include="Nca\SolutionCreation\NcaSolutionCreator.cs" />
-    <Compile Include="NearestNeighbour\NearestNeighbourClassification.cs" />
-    <Compile Include="NearestNeighbour\NearestNeighbourClassificationSolution.cs" />
-    <Compile Include="NearestNeighbour\NearestNeighbourModel.cs" />
-    <Compile Include="NearestNeighbour\NearestNeighbourRegression.cs" />
-    <Compile Include="NearestNeighbour\NearestNeighbourRegressionSolution.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkEnsembleClassification.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkEnsembleClassificationSolution.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkEnsembleModel.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkEnsembleRegressionSolution.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkEnsembleRegression.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkClassification.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkClassificationSolution.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkModel.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkRegression.cs" />
-    <Compile Include="NeuralNetwork\NeuralNetworkRegressionSolution.cs" />
-    <Compile Include="NonlinearRegression\NonlinearRegression.cs" />
-    <Compile Include="Plugin.cs" />
-    <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="RandomForest\RandomForestClassificationSolution.cs" />
-    <Compile Include="RandomForest\RandomForestClassification.cs" />
-    <Compile Include="RandomForest\RandomForestModel.cs" />
-    <Compile Include="RandomForest\RandomForestRegression.cs" />
-    <Compile Include="RandomForest\RandomForestRegressionSolution.cs" />
-    <Compile Include="RandomForest\RandomForestUtil.cs" />
-    <Compile Include="SupportVectorMachine\SupportVectorClassification.cs" />
-    <Compile Include="SupportVectorMachine\SupportVectorClassificationSolution.cs" />
-    <Compile Include="SupportVectorMachine\SupportVectorMachineModel.cs" />
-    <Compile Include="SupportVectorMachine\SupportVectorMachineUtil.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="SupportVectorMachine\SupportVectorRegression.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="SupportVectorMachine\SupportVectorRegressionSolution.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="TimeSeries\AutoregressiveModeling.cs" />
-    <Compile Include="TSNE\Distances\CosineDistance.cs" />
-    <Compile Include="TSNE\Distances\DistanceBase.cs" />
-    <Compile Include="TSNE\Distances\EuclideanDistance.cs" />
-    <Compile Include="TSNE\Distances\IndexedItemDistance.cs" />
-    <Compile Include="TSNE\Distances\ManhattanDistance.cs" />
-    <Compile Include="TSNE\Distances\WeightedEuclideanDistance.cs" />
-    <Compile Include="TSNE\Distances\IDistance.cs" />
-    <Compile Include="TSNE\PriorityQueue.cs" />
-    <Compile Include="TSNE\SpacePartitioningTree.cs" />
-    <Compile Include="TSNE\TSNEAlgorithm.cs" />
-    <Compile Include="TSNE\TSNEStatic.cs" />
-    <Compile Include="TSNE\TSNEUtils.cs" />
-    <Compile Include="TSNE\VantagePointTree.cs" />
-  </ItemGroup>
-  <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Algorithms.GradientDescent\3.3\HeuristicLab.Algorithms.GradientDescent-3.3.csproj">
-      <Project>{1256B945-EEA9-4BE4-9880-76B5B113F089}</Project>
-      <Name>HeuristicLab.Algorithms.GradientDescent-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm\3.3\HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm-3.3.csproj">
-      <Project>{F409DD9E-1E9C-4EB1-AA3A-9F6E987C6E58}</Project>
-      <Name>HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
-      <Project>{887425B4-4348-49ED-A457-B7D2C26DDBF9}</Project>
-      <Name>HeuristicLab.Analysis-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
-      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
-      <Name>HeuristicLab.Collections-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.3\HeuristicLab.Common.Resources-3.3.csproj">
-      <Project>{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}</Project>
-      <Name>HeuristicLab.Common.Resources-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
-      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
-      <Name>HeuristicLab.Common-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
-      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
-      <Name>HeuristicLab.Core-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
-      <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
-      <Name>HeuristicLab.Data-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Encodings.RealVectorEncoding\3.3\HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj">
-      <Project>{BB6D334A-4BB6-4674-9883-31A6EBB32CAB}</Project>
-      <Name>HeuristicLab.Encodings.RealVectorEncoding-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding\3.4\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj">
-      <Project>{06D4A186-9319-48A0-BADE-A2058D462EEA}</Project>
-      <Name>HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
-      <Project>{23DA7FF4-D5B8-41B6-AA96-F0561D24F3EE}</Project>
-      <Name>HeuristicLab.Operators-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
-      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
-      <Name>HeuristicLab.Optimization-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
-      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
-      <Name>HeuristicLab.Parameters-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
-      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
-      <Name>HeuristicLab.Persistence-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
-      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
-      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic.Classification\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.Classification-3.4.csproj">
-      <Project>{05BAE4E1-A9FA-4644-AA77-42558720159E}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Symbolic.Classification-3.4</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic.Regression\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4.csproj">
-      <Project>{5AC82412-911B-4FA2-A013-EDC5E3F3FCC2}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Symbolic.Regression-3.4</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4.csproj">
-      <Project>{07486E68-1517-4B9D-A58D-A38E99AE71AB}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis-3.4</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Symbolic\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj">
-      <Project>{3D28463F-EC96-4D82-AFEE-38BE91A0CA00}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Symbolic-3.4</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
-      <Project>{DF87C13E-A889-46FF-8153-66DCAA8C5674}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis-3.4</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.Instances\3.3\HeuristicLab.Problems.Instances-3.3.csproj">
-      <Project>{3540E29E-4793-49E7-8EE2-FEA7F61C3994}</Project>
-      <Name>HeuristicLab.Problems.Instances-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Random\3.3\HeuristicLab.Random-3.3.csproj">
-      <Project>{F4539FB6-4708-40C9-BE64-0A1390AEA197}</Project>
-      <Name>HeuristicLab.Random-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Selection\3.3\HeuristicLab.Selection-3.3.csproj">
-      <Project>{2C36CD4F-E5F5-43A4-801A-201EA895FE17}</Project>
-      <Name>HeuristicLab.Selection-3.3</Name>
-    </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="HeuristicLab.snk" />
-    <None Include="Plugin.cs.frame" />
-    <None Include="Properties\AssemblyInfo.cs.frame" />
-  </ItemGroup>
-  <ItemGroup>
-    <BootstrapperPackage Include="Microsoft.Net.Client.3.5">
-      <Visible>False</Visible>
-      <ProductName>.NET Framework 3.5 SP1 Client Profile</ProductName>
-      <Install>false</Install>
-    </BootstrapperPackage>
-    <BootstrapperPackage Include="Microsoft.Net.Framework.3.5.SP1">
-      <Visible>False</Visible>
-      <ProductName>.NET Framework 3.5 SP1</ProductName>
-      <Install>true</Install>
-    </BootstrapperPackage>
-    <BootstrapperPackage Include="Microsoft.Windows.Installer.3.1">
-      <Visible>False</Visible>
-      <ProductName>Windows Installer 3.1</ProductName>
-      <Install>true</Install>
-    </BootstrapperPackage>
-  </ItemGroup>
-  <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
-  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
-       Other similar extension points exist, see Microsoft.Common.targets.
-  <Target Name="BeforeBuild">
+  <Target Name="PreBuild" BeforeTargets="PreBuildEvent">
+    <Exec Command="set Path=%Path%;$(ProjectDir);$(SolutionDir)&#xD;&#xA;set ProjectDir=$(ProjectDir)&#xD;&#xA;set SolutionDir=$(SolutionDir)&#xD;&#xA;set Outdir=$(Outdir)&#xD;&#xA;call PreBuildEvent.cmd" />
   </Target>
-  <Target Name="AfterBuild">
-  </Target>
-  -->
-  <PropertyGroup>
-    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
-set ProjectDir=$(ProjectDir)
-set SolutionDir=$(SolutionDir)
-set Outdir=$(Outdir)
-
-call PreBuildEvent.cmd
-</PreBuildEvent>
-    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
-export ProjectDir=$(ProjectDir)
-export SolutionDir=$(SolutionDir)
-
-$SolutionDir/PreBuildEvent.sh
-</PreBuildEvent>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|AnyCPU'">
+    <OutputPath>..\..\bin\</OutputPath>
+    <AppendTargetFrameworkToOutputPath>false</AppendTargetFrameworkToOutputPath>
   </PropertyGroup>
 </Project>
